MODULE DETERMINANTE
        REAL*8 :: DET, TFinal
        INTEGER :: LengthParam,LengthJParam
END MODULE DETERMINANTE
!MODULE GlobalParam
!       Integer IElem_G, NelT_G, NodT_G, nOldTimeSteps_G
!       Integer IE_G(1),JE_G(1),ElementType_G(1),ElementMat_G(1)
!       REAL*8 Sol0_G(1),Sol1_G(1),X_G(1)
!       Pointer (p_IE,IE_G), (p_JE,JE_G)
!       Pointer (p_ET,ElementType_G),(p_EM,ElementMat_G)
!       Pointer (p_S0,Sol0_G),(p_S1,Sol1_G),(p_X,X_G)
!END MODULE GlobalParam

!      Module MatCoef
!      contains                                                          
                                                                         
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!                         SubRoutine MatrixCoef                           
!                                                                       
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
! ElementLib()	  :	element library
!                     contains
!                            1 Id_Elem_Family : General Element Family
!                            2 The group of elemnts is additive or not
!                            3 
!                            4 Id_Coup   : Coupling Property set ID
!
!
! MaxElemlib    :     Total Number of Elements in ElementLib
!
!_______________________________________________________________________
	  SubRoutine MatrixCoef                                             &  
     &    (IE,JE,X,                                                     &
     &     IA,JA,AN,ANT,AD,                                             &
     &     Sol0,Sol1,B_Load,                                            &
     &     iDofType,iAdd,IP,                                            &
     &     Param,JParam,CommonPar,                                      &
     &     Ie__Param,Ie_JParam,MaxDatSet,                               &
     &     ElementType,ElementMat,ElementLib,                           &
     &     Coupling,                                                    &
     &     IEqNode,IEqDof,IEqT,                                         &
     &     NodT,NelT,iDofT,NDim,MaxNodEl,MaxElemlib,MaxLCommonPar,      &
     &     iRowT,MaxLRows,Sym,                                          &
     &     DelT,DTm,Time,nOldTimeSteps,iControl )

      USE DETERMINANTE
 !     USE GlobalParam
      IMPLICIT REAL*8 (A-H,O-Z)
!      COMMON /Deter/ Det,LengthParam,LengthJParam

      DIMENSION IE(1),JE(1),X(1),                                       &
     &     IA(1),JA(1),AN(1),ANT(1),AD(1),                              &
     &     Sol0(1),Sol1(1),B_Load(1),                                   &
     &     iDofType(1),iAdd(1),IP(1),                                   &
     &     Param(1),JParam(1),CommonPar(MaxLCommonPar,1),               &
!    &     Ie__Param(1),Ie_JParam(1),Je__Param(1),Je_JParam(1),         &
     &     Ie__Param(1),Ie_JParam(1),                                   &
     &     IEqNode(1),IEqDof(1),IEqT(1),iControl(1)                     
	Logical Sym
      Integer ElementType(1),ElementMat(1),ElementLib(MaxElemLib,1),    &
     &        Coupling(MaxLRows,MaxLRows,1)   	 

      DIMENSION AE(MaxLRows,MaxLRows),XL(MaxNodEl*Ndim),Nodes(MaxNodEl), &
     &Sol0_Elem(MaxLRows*nOldTimeSteps),Sol1_Elem(MaxLRows),BE(MaxLRows) 

   p_IE=LOC(IE)
   p_JE=LOC(JE)
   p_ET=LOC(ElementType)
   p_EM=LOC(ElementMat)
   p_S0=LOC(Sol0)
   p_S1=LOC(Sol1)
   p_X =LOC(X)
   NelT_G = NelT
   NodT_G = NodT
   nOldTimeSteps_G = nOldTimeSteps
    
 	DTm = DelT
	iElem = 0

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	Do While ( iElem < NelT )
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
          iElem     = iElem + 1
          IElem_G   = iElem

	do iC=1,MaxLrows
                        BE(iC)    = 0.0d0	
    do iR=1,MaxLrows
                        AE(iR,iC) = 0.0d0
	Enddo
	Enddo

          Id_DataSet = ElementMat  (iElem)
          IdElemLib  = ElementType (iElem)

            Id_Elem_Family            = ElementLib(IdElemLib,1)
            Id_Add                    = ElementLib(IdElemLib,2)
            Id_Coup                   = ElementLib(IdElemLib,4)
            If(Id_Coup==0)Cycle


!            Id_Elem_NodeType          = ElementLib(IdElemLib,4)
!	write(*,*)'Elem=',ielem,Id_Elem_Family

            iE1 = IE(iElem)
            ipJE1 = IE1-1
            NodEl                     = IE(iElem+1)-IE1

            iPar  = Ie__Param(Id_DataSet)
            iJPar = Ie_JParam(Id_DataSet)
			LengthParam  = Ie__Param(MaxDatSet+1) - 1
			LengthJParam = Ie_JParam(MaxDatSet+1) - 1


            Do N=1,NodEl
              Node = JE (ipJE1 + N)
              Nodes(N) = Node
	        NN    = Ndim * (N    - 1)
	        NNode = Ndim * (Node - 1)
              Do iDim=1, NDim
                          XL ( NN + iDim ) = X ( NNode + iDim )
              Enddo  
            Enddo  
!		if(iElem==396)then
!	        write(33,*)NodEL
!	        write(33,*)Nodes
!	        write(33,*)XL
!		endif
            Do N=1,NodEl
              ipLocal  = (N-1) * iDofT
              ipGlobal = ( Nodes(N)-1 )*iDofT
             Do iDof=1,iDofT
              ipLocal1  = ipLocal  + iDof
              ipGlobal1 = ipGlobal + iDof
              Sol1_Elem(ipLocal1) = Sol1(ipGlobal1)
             Enddo  
            Enddo  

          LenUnK_G = NodT *iDofT 
          LenUnK_L = NodEl*iDofT 
          Do KNT = 1 , nOldTimeSteps 
            iShG  = (KNT-1) * LenUnK_G
            iShL  = (KNT-1) * LenUnK_L
            Do N=1,NodEl
              ipLocal  =     (N-1)     * iDofT + iShL
              ipGlobal = ( Nodes(N)-1 )* iDofT + iShG
              Do iDof=1,iDofT
               ipLocal1  = ipLocal  + iDof
               ipGlobal1 = ipGlobal + iDof
               Sol0_Elem(ipLocal1) = Sol0(ipGlobal1)
              Enddo  
            Enddo  
          End do
!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
          Element_Family: SelectCase (Id_Elem_Family)
!_______________________________________________________________________
!   -----------------------------------------------
!   -----------------------------------------------
!	Elementos utilizados en problemas de FEM

          Case (1)
	    Call PoissonFEM_1                                           &
     &                  ( AE,BE,MaxLRows,XL,NDim,iDofT,NodEl,           &
     &                    Sol0_Elem,Sol1_Elem,CommonPar(1,IdElemLib),   &
     &                    Param(iPar),JParam(iJPar),DelT,DTm,Time    )

          Case (2)
	    Call PoissonFEM_2                                           &
     &                  ( AE,BE,MaxLRows,XL,NDim,iDofT,NodEl,           &
     &                    Sol0_Elem,Sol1_Elem,CommonPar(1,IdElemLib),   &
     &                    Param(iPar),JParam(iJPar),DelT,DTm,Time    )

          Case (11)
	    Call NeumannElement                                         &
     &                  ( AE,BE,MaxLRows,XL,NDim,iDofT,NodEl,           &
     &                    Sol0_Elem,Sol1_Elem,CommonPar(1,IdElemLib),   &
     &                    Param(iPar),JParam(iJPar),DelT,DTm,Time    )

          Case (12)
	    Call ConcentratedLoad                                         &
     &                  ( AE,BE,MaxLRows,XL,NDim,iDofT,NodEl,           &
     &                    Sol0_Elem,Sol1_Elem,CommonPar(1,IdElemLib),   &
     &                    Param(iPar),JParam(iJPar),DelT,DTm,Time    )


!   -----------------------------------------------
!   -----------------------------------------------
!	Elementos utilizados en problemas de BEM(1xx)

!   Elemento de Laplace con formulacion de BEM con interpolaci�n constante
!   (ensamblaje en la matriz)(campo cercano)
!   (elementos de a pares)
          Case (101)
	    Call Laplace_BEM_C_M_2D                                         &
     &                  ( AE,BE,MaxLRows,XL,NDim,iDofT,NodEl,           &
     &                    Sol0_Elem,Sol1_Elem,CommonPar(1,IdElemLib),   &
     &                    Param(iPar),JParam(iJPar),DelT,DTm,Time    )

!   Elemento de Laplace con formulacion de BEM con interpolaci�n constante
!   (ensamblaje en la diagonal de la matriz matriz)(campo cercano)
!   (elementos de contorno)
          Case (103)
	    Call Laplace_BEM_C_D_2D                                         &
     &                  ( AE,BE,MaxLRows,XL,NDim,iDofT,NodEl,           &
     &                    Sol0_Elem,Sol1_Elem,CommonPar(1,IdElemLib),   &
     &                    Param(iPar),JParam(iJPar),DelT,DTm,Time    )


	    Case Default
                   Write(*,*) '!!!!!!! WARNING, ELEMENT NOT IDENTIFIED'	
!_______________________________________________________________________


          End Select Element_Family  
!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&


!     Asembles LocalElement Matrix in Global Matrix

if (Det .lt. 0.0d0) then
       Write(6,*)'WARNING, jacobian < 0 at element',iElem,Det

            Write(6,*)'Id_Elem_Family',Id_Elem_Family
            X11= 0.0
            X22= 0.0
            X33= 0.0

            Do N=1,NodEl
	        NN    = Ndim * (N    - 1)
            X11= X11 +  XL ( NN + 1 )/NodEl
            X22= X22 +  XL ( NN + 2 )/NodEl
            X33= X33 +  XL ( NN + 3 )/NodEl
            Enddo  
            write(6,*)'Coordinates',X11,X22,X33

End if


      Call EnsNumGen ( AE,Nodes,IA,JA,AN,ANT,AD,                        &
     &      B_Load,BE,IP,IEqT,Coupling(1,1,Id_Coup),                    &
     &      iDofType,MaxLRows,iDofT,NodEl,Id_Add,iAdd,Sym)



!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	End Do
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 Return

End Subroutine
!      end module MatCoef
!-----------------------------------------------------------------------
      SUBROUTINE EnsNumGen ( AE,Nodes,IA,JA,AGlobal_U,AGlobal_L,AD,             &
     &      BG,BE,IP,IEqT,iCoupling,DofType,MaxLRows,DofT,NodEl,Id_Add,iAdd,Sym)

!     ojo con MaxLRows=DofT*MaxNodEl
!     NetRows = IpIELocal(IdelemLib + 1 ) - IpIELocal( IdelemLib )
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER   DofT,DofR,DofC,PunJA,DofType(1)
      DIMENSION AE(MaxLRows,1),Nodes(1),IA(1),JA(1),                    &
     &          AGlobal_U(1),AGlobal_L(1),AD(1),BG(1),BE(1),IP(1),      &
     &          IEqT(1),iAdd(1),iCoupling(MaxLRows,MaxLRows)
	Logical Sym,NOTSym
	NOTSym = .not. Sym	     
!--------------------------          
      DO NodR=1, NodEl
          
        ipLRow       = ( NodR -1)*DofT
        NodRGlobal   = Nodes (NodR)
        iPGlobalR    = (NodRGlobal-1)*DofT
      DO DofR=1, DofT
!--------------------------
         LRow          = ipLRow  + DofR
!         NodR         = LocalNodeR (L)        
!         DofR         = LocalDofR  (L)        
         IpIEqTR       = iPGlobalR + DofR
         iRow          = IEqT   ( IpIEqTR )
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
	   if ( iRow.Ne. 0 ) then 
            NodeTypeR     = DofType( IpIEqTR )
!      if(iAdd(iRow).Eq.0 .or. Id_Add .Eq. 1) then
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!         IP (iRow) = LRow
!	  Dirichlet Row
            if (NodeTypeR.GT.0) Then
!               Not a Dirichlet Row

!               if(iAdd(iRow).Eq.0 .or. Id_Add .Eq. 1) then
                if(iAdd(iRow).Eq.0 ) then
!               assembling the diagonal
                AD(iRow)  = AD(iRow) + AE(LRow,LRow)
                BG(iRow)  = BG(iRow) + BE(LRow)
            elseif (iCoupling(LRow,LRow).LT.0 )then 

                AD(iRow)  = AD(iRow) + AE(LRow,LRow)
                BG(iRow)  = BG(iRow) + BE(LRow)
            Endif

          Do NodC=1,NodEl
	        ipLCol       = ( NodC -1)*DofT
            NodCGlobal   = Nodes (NodC)
	        iPGlobalC    = (NodCGlobal-1)*DofT

            Do DofC=1,DofT
			   LCol        = ipLCol + DofC        
              if ( iCoupling(LRow,LCol) .NE. 0 ) then 
                  IpIEqTC     = iPGlobalC + DofC
                  iCol        = IEqT   ( IpIEqTC )
			      NodeTypeC   = DofType( IpIEqTC )

!			    Dirichlet	Col
				    IF (NodeTypeC.GT.0) Then	
				        IF (iCol .GT. iRow) then
                                              IP (iCol) = LCol
!                        ElseIf (iCol .Eq. iRow) then
!                                   AD(iRow)  = AD(iRow) + AE(LRow,LCol)
                        Endif
				    Else
!                      Dirichlet Column 
                     if(iAdd(iRow).Eq.0 ) then
				        BG(iRow)   = BG(iRow) - AE(LRow,LCol)*BG(iCol)
                     elseif (iCoupling(LRow,LRow).LT.0 )then 
				        BG(iRow)   = BG(iRow) - AE(LRow,LCol)*BG(iCol)
                     Endif
                    
                    Endif

               Endif
            End Do
          End Do

           IAA = IA(iRow)
           IAB = IA(iRow+1)-1

           DO PunJA = IAA,IAB
               iColGl= JA(PunJA)      
               LCol = IP ( iColGl )

             IF ( LCol .NE. 0 ) then 
!            IF(iAdd(iRow).Eq.0 .or. Id_Add .Eq. 1) then
               IF(iAdd(iRow).Eq.0 ) then
	                                      AGlobal_U(PunJA) = AGlobal_U(PunJA) + AE(LRow,LCol)
                elseif (iCoupling(LRow,LRow).LT.0 )then 
                                          AGlobal_U(PunJA) = AGlobal_U(PunJA) + AE(LRow,LCol)
               Endif
               if (NOTSym) then	
!               IF(iAdd(iColGl).Eq.0 .or. Id_Add .Eq. 1) then
                 IF(iAdd(iColGl).Eq.0 ) then
                                            AGlobal_L(PunJA) = AGlobal_L(PunJA) + AE(LCol,LRow)
                 elseif (iCoupling(LCol,LCol).LT.0 )then 
                                            AGlobal_L(PunJA) = AGlobal_L(PunJA) + AE(LCol,LRow)
                 Endif
               Endif
                    IP ( iColGl ) = 0
            
             ENDIF

           Enddo


         Else  
!               A Dirichlet Row . If comented, dirichlet are treated in
!                AD(iRow)=1.0d0

         Endif
!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
!      cierra if  aditividad
!      Endif
! cierra si la fila no esta
      Endif
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

!--------------------------          
      End Do
     End Do
!--------------------------          
      RETURN
	END subroutine




